$(function(){
    $('#paper').css({'visibility':'hidden'});
});

$(window).on('load', function() {

    mousedown = false;

    $(document).on('mouseup touchend', function(){mousedown=false});


    // put newspaper on canvas!!1

    var source = new Image();
    source.src = $('#paper > img').attr('src');
    
    $('#paper').css('width',source.width);

    var paper = $('<canvas>')[0];
    paper.width = source.width;
    paper.height = source.height;

    var paper_ctx = paper.getContext('2d');
    paper_ctx.drawImage(source, 0, 0);

    var peel = $('<canvas>')[0];
    var peel_ctx = peel.getContext('2d');

    var id = 0;

    $.each(peels, function() {
        var width = this.x2-this.x1;
        var height = this.y2-this.y1;
        peel.width = width/2;
        peel.height = height;     

        peel_ctx.drawImage(paper, this.x1+width/2, this.y1, width/2, height, 0, 0, width/2, height);
        var img_data = peel.toDataURL();
        var page_1 = $('<div>').css('background-image', 'url(' + img_data +')');
        
        var bg_position_left = 'top right';
        var bg_position_right = 'top left';

        if(this.paper) {
            bg_position_left = 'top left';
            bg_position_right = 'top right';
        }

        var page_2 = $('<div>').css({'background-image':'url(' + this.stars +')', 'background-position':bg_position_left});
        var page_3 = page_2.clone().css({'background-position':bg_position_right});

        var hole = $('<div>')
            .addClass('hole')
            .css({left: this.x1, top: this.y1, width:width, height:height});

        var tear = $('<div>')
            .attr('id', 'tear_'+id)
            .css({width:width, height:height})
            .addClass('tear')
            .append(page_1)
            .append(page_2)
            .append(page_3)
                .appendTo(hole);

        hole.appendTo('#paper');

        $('<style type="text/css">#tear_'+id+' .turn-page {background: #ccc url('+this.paper+');}</style>').appendTo('head');

        id++;


    });

    var turn_opts = {display:'double',acceleration: true,gradients: true,elevation:50,inclination:10,cornerSize:200};
    var hints = $('.tear').each(function(){
        var $this = $(this);
        $this.turn(turn_opts);    
    });
    
    // global function!!
    animation_factory = function(params) {
        
        params = $.extend(
            {
                peel: 0,
                amplitude: 0.5,   
                wave: 1,
                steps: 100,
                edge: 'top',
                cancel: 9999,
                pause_after: 200,
            }
            , params);

        return function() {
            var $peel = $('div.tear').eq(params.peel);

            var direction = ($peel.data('state')=='closed' || !$peel.data('state')) ? 'open' : 'close';
            var pos = $peel.offset();
            var width = $peel.width();
            var height = $peel.height();

            var x_start, x_end;
            if(direction == 'open') {
                x_start = pos.left+width -5;
                x_end = pos.left;
            }
            else {
                x_start = pos.left+5;
                x_end = pos.left+width;   
            }

            var y_start;
            if(params.edge == 'top') {
                y_start = pos.top+5;
            }
            else {
                y_start = pos.top+height-5;
            }

            var coords = [];
            for(var step=1;step<=params.steps+1;step++) {
                var coord = {
                    x: x_start - Math.round(((x_start-x_end)/params.steps) * (step-1)),
                    y: (y_start) - (Math.round( Math.sin( (Math.PI*params.wave/params.steps)*(step-1) ) * (height*params.amplitude)))
                }
                coords.push(coord);
            }

            var frame = 0;
            var mousePilot = function() {
                var fakeEvent = 'fake_mousemove';
                var targetElement = document;
                if(frame==0) {
                    fakeEvent = 'fake_mousedown';
                    targetElement = $peel[0];
                }
                if(frame==params.cancel) {
                    fakeEvent = 'fake_mouseup';
                    coords = [coords.shift()];
                }
                if(coords.length==1) fakeEvent = 'fake_mouseup';
                coord = coords.shift();
                frame++;

                var fakeMouse = $.Event(fakeEvent, {'pageX': coord.x, 'pageY': coord.y, originalEvent:true, fake:true});

                $(targetElement).trigger(fakeMouse);

                if(coords.length>0) {
                    setTimeout(mousePilot, 20)
                }
                else {
                    
                    if(params.cancel>params.steps/2) {
                        if(direction=='open')
                            $peel.data('state','open')
                        else
                            $peel.data('state','closed');
                    }
                    $peel.css('z-index', '1');
                    setTimeout(function(){
                        $(document).trigger('next')
                    }, params.pause_after);
                }

            }

            $peel.css('z-index', '2');
            mousePilot();

        }
    }

    $('#paper').css({'visibility':'visible'});

    $(document).trigger('next');

});
