$(function(){
    $('#paper').css({'visibility':'hidden'});
});



$(window).on('load', function() {



    mousedown = false;

    $(document).on('mouseup touchend', function(){mousedown=false});


    // put newspaper on canvas!!1

    var source = new Image();
    source.src = $('#paper > img').attr('src');
    
    $('#paper').css('width',source.width);

    var paper = $('<canvas>')[0];
    paper.width = source.width;
    paper.height = source.height;

    var paper_ctx = paper.getContext('2d');
    paper_ctx.drawImage(source, 0, 0);

    var peel = $('<canvas>')[0];
    var peel_ctx = peel.getContext('2d');

    var id = 0;

    $.each(peels, function() {
        var width = this.x2-this.x1;
        var height = this.y2-this.y1;
        peel.width = width/2;
        peel.height = height;     

        peel_ctx.drawImage(paper, this.x1+width/2, this.y1, width/2, height, 0, 0, width/2, height);
        var img_data = peel.toDataURL();
        var page_1 = $('<div>').css('background-image', 'url(' + img_data +')');
        
        var bg_position_left = 'top right';
        var bg_position_right = 'top left';

        if(this.paper) {
            bg_position_left = 'top left';
            bg_position_right = 'top right';
        }

        var page_2 = $('<div>').css({'background-image':'url(' + this.stars +')', 'background-position':bg_position_left});
        var page_3 = page_2.clone().css({'background-position':bg_position_right});

        var hole = $('<div>')
            .addClass('hole')
            .css({left: this.x1, top: this.y1, width:width, height:height});

        var tear = $('<div>')
            .attr('id', 'tear_'+id)
            .css({width:width, height:height})
            .addClass('tear')
            .append(page_1)
            .append(page_2)
            .append(page_3)
                .appendTo(hole);

        hole.appendTo('#paper');

        $('<style type="text/css">#tear_'+id+' .turn-page {background: #ccc url('+this.paper+');}</style>').appendTo('head');

        id++;


    })

    var turn_opts = {display:'double',acceleration: true,gradients: true,elevation:50,inclination:10,cornerSize:200};
    var hints = $('.tear').each(function(){
        var $this = $(this);
        $this.turn(turn_opts);    
    });

    var isTouch = 'ontouchstart' in window;

    var hint_counter = 0;

    var tickleAnimation = setInterval(function(){
        if(mousedown) return;
        var current_hint = $(hints[hint_counter]);

        var pos = current_hint.offset();
        var width = current_hint.width();
        var height = current_hint.height();

        var x = pos.left+width-3;
        var y = pos.top+3;

        var fakeMouse;

        if(isTouch) {
            var eventOpts = { 'originalEvent': { 'touches': [{'pageX': x, 'pageY': y, originalEvent:true, fake:true}]}};
            eventOpts.originalEvent.touches[0].originalEvent = eventOpts.originalEvent; // circular options!
            fakeMouse = $.Event('touchmove', eventOpts);
        }
        else {
            fakeMouse = $.Event('mousemove', {'pageX': x, 'pageY': y, originalEvent:true, fake:true});
        }

        $(document).trigger(fakeMouse);

        hint_counter++;
        if(hint_counter == hints.length) hint_counter = 0;

    }, 1500);

    $('#paper').css({'visibility':'visible'});

});
